// AppMain.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "AppMain.h"


#include "openspc++\main.cpp"
#include "openspc++\dsp.cpp"
#define WORDS_BIGENDIAN
#include "openspc++\spc.cpp"
#undef WORDS_BIGENDIAN

#define BUFFER_SAMPLE					4096
#define BUFFER_COUNT					8
#define BUFFER_PRELOAD					6

#define MAIN_WINDOW_CLASS				_T("Dialog")
#define MAIN_WINDOW_TEXT				_T("SPC Player")

#define SETTINGS_FADEOUTPOSITION		_T("FadeoutPosition")
#define SETTINGS_FADEOUTFACTOR			_T("FadeoutFactor")
#define SETTINGS_SILENCETIMEOUT			_T("SilenceTimeout")
#define SETTINGS_VOLUME					_T("Volume")

HINSTANCE g_hInstance;
TCHAR g_AppPath[MAX_PATH];
TCHAR g_AppDir[MAX_PATH];
WNDPROC g_OldListBoxProc;
BOOL g_bReady;
openspc g_OpenSPC;
HWAVEOUT g_hWaveOut;
WAVEFORMATEX g_Format;
BYTE* g_pBuffer;
WAVEHDR g_Hdr[BUFFER_COUNT];
BOOL g_bPlay;
DWORD g_Written;
DWORD g_Position;
LONG g_Volume;
DWORD g_FadeoutPosition;
LONG g_FadeoutFactor;
DWORD g_SilenceTimeout;
LONG g_FadeVolume;
DWORD g_SilenceCount;
BYTE* g_pFile;
DWORD g_dwFile;
TCHAR g_SPCTitle[33];
LONG g_CurrentIndex;

void GetDirFromFullPath(LPTSTR Dest, LPCTSTR File)
{
	TCHAR* p;
	_tcscpy(Dest, File);
	p = _tcsrchr(Dest, _T('\\'));
	if(p)
		*p = _T('\0');
}

void SetAppDir()
{
	GetModuleFileName(NULL, g_AppPath, MAX_PATH - 1);
	GetDirFromFullPath(g_AppDir, g_AppPath);
}

void GetFileNameFromFullPath(LPTSTR Dest, LPCTSTR File)
{
	TCHAR* p;
	_tcscpy(Dest, File);
	p = _tcsrchr(File, _T('\\'));
	if(p)
	{
		p++;
		_tcscpy(Dest, p);
	}
}

BOOL ParseSettingsText(TCHAR* pData)
{
	TCHAR* pNext;
	TCHAR* pValue;
	TCHAR* pName;
	__try
	{
		while(*pData != _T('\0'))
		{
			pNext = pData;
			while(*pNext != _T('\r'))
			{
				pNext++;
			}
			*pNext = _T('\0');
			pNext += 2;
			pName = pData;
			pValue = pData;
			while(*pValue != _T('='))
			{
				pValue++;
			}
			*pValue = _T('\0');
			pValue++;
			if(_tcscmp(pName, SETTINGS_FADEOUTPOSITION) == 0)
				g_FadeoutPosition = (DWORD)_tcstol(pValue, NULL, 0);
			else if(_tcscmp(pName, SETTINGS_FADEOUTFACTOR) == 0)
				g_FadeoutFactor = _tcstol(pValue, NULL, 0);
			else if(_tcscmp(pName, SETTINGS_SILENCETIMEOUT) == 0)
				g_SilenceTimeout = (DWORD)_tcstol(pValue, NULL, 0);
			else if(_tcscmp(pName, SETTINGS_VOLUME) == 0)
				g_Volume = _tcstol(pValue, NULL, 0);
			pData = pNext;
		}
	}
	__except(true)
	{
		return FALSE;
	}
	return TRUE;
}

BOOL LoadSettings(LPCTSTR FileName)
{
	HANDLE hFile;
	TCHAR* pBuf;
	DWORD dwBuf;
	DWORD dw;
	hFile = CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
		return FALSE;
	dwBuf = GetFileSize(hFile, NULL) / sizeof(TCHAR);
	pBuf = new TCHAR[dwBuf + 1];
	if(!pBuf)
	{
		CloseHandle(hFile);
		return FALSE;
	}
	ReadFile(hFile, pBuf, sizeof(TCHAR) * dwBuf, &dw, NULL);
	if(dw != sizeof(TCHAR) * dwBuf)
	{
		CloseHandle(hFile);
		delete []pBuf;
		return FALSE;
	}
	pBuf[dwBuf] = _T('\0');
	CloseHandle(hFile);
	if(*pBuf != 0xfeff)
	{
		delete []pBuf;
		return FALSE;
	}
	ParseSettingsText(pBuf + 1);
	delete []pBuf;
	return TRUE;
}

BOOL SaveSettings(LPCTSTR FileName)
{
	HANDLE hFile;
	TCHAR Temp[MAX_PATH + 32];
	DWORD dw;
	hFile = CreateFile(FileName, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
		return FALSE;
	Temp[0] = 0xfeff;
	WriteFile(hFile, &Temp[0], sizeof(TCHAR), &dw, NULL);
	_stprintf(Temp, _T("%s=%d\r\n"), SETTINGS_FADEOUTPOSITION, g_FadeoutPosition);
	WriteFile(hFile, &Temp, sizeof(TCHAR) * _tcslen(Temp), &dw, NULL);
	_stprintf(Temp, _T("%s=%d\r\n"), SETTINGS_FADEOUTFACTOR, g_FadeoutFactor);
	WriteFile(hFile, &Temp, sizeof(TCHAR) * _tcslen(Temp), &dw, NULL);
	_stprintf(Temp, _T("%s=%d\r\n"), SETTINGS_SILENCETIMEOUT, g_SilenceTimeout);
	WriteFile(hFile, &Temp, sizeof(TCHAR) * _tcslen(Temp), &dw, NULL);
	_stprintf(Temp, _T("%s=%d\r\n"), SETTINGS_VOLUME, g_Volume);
	WriteFile(hFile, &Temp, sizeof(TCHAR) * _tcslen(Temp), &dw, NULL);
	CloseHandle(hFile);
	return TRUE;
}

BOOL LoadPlaylist(LPCTSTR FileName, HWND hListBox)
{
	HANDLE hFile;
	TCHAR* pBuf;
	DWORD dwBuf;
	DWORD dw;
	TCHAR* pCur;
	TCHAR* pNext;
	TCHAR* pFileName;
	LONG Index;
	hFile = CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
		return FALSE;
	dwBuf = GetFileSize(hFile, NULL) / sizeof(TCHAR);
	pBuf = new TCHAR[dwBuf + 1];
	if(!pBuf)
	{
		CloseHandle(hFile);
		return FALSE;
	}
	ReadFile(hFile, pBuf, sizeof(TCHAR) * dwBuf, &dw, NULL);
	if(dw != sizeof(TCHAR) * dwBuf)
	{
		CloseHandle(hFile);
		delete []pBuf;
		return FALSE;
	}
	pBuf[dwBuf] = _T('\0');
	CloseHandle(hFile);
	if(*pBuf != 0xfeff)
	{
		delete []pBuf;
		return FALSE;
	}
	pCur = pBuf;
	pCur++;
	__try
	{
		while(*pCur != _T('\0'))
		{
			pNext = pCur;
			while(*pNext != _T('\r'))
			{
				pNext++;
			}
			*pNext = _T('\0');
			pNext += 2;
			pFileName = new TCHAR[MAX_PATH];
			if(pFileName)
			{
				_tcscpy(pFileName, pCur);
				GetFileNameFromFullPath(pCur, pFileName);
				Index = (LONG)SendMessage(hListBox, LB_ADDSTRING, 0, (LPARAM)pCur);
				if(Index >= 0)
					SendMessage(hListBox, LB_SETITEMDATA, (WPARAM)Index, (LPARAM)pFileName);
			}
			pCur = pNext;
		}
	}
	__except(true)
	{
	}
	delete []pBuf;
	return TRUE;
}

BOOL SavePlaylist(LPCTSTR FileName, HWND hListBox)
{
	HANDLE hFile;
	TCHAR Temp[MAX_PATH + 32];
	DWORD dw;
	TCHAR* pFileName;
	LONG Index;
	hFile = CreateFile(FileName, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
		return FALSE;
	Temp[0] = 0xfeff;
	WriteFile(hFile, &Temp[0], sizeof(TCHAR), &dw, NULL);
	Index = 0;
	pFileName = (TCHAR*)SendMessage(hListBox, LB_GETITEMDATA, (WPARAM)Index, 0);
	while(pFileName != (TCHAR*)LB_ERR)
	{
		if(pFileName)
		{
			_stprintf(Temp, _T("%s\r\n"), pFileName);
			WriteFile(hFile, &Temp, sizeof(TCHAR) * _tcslen(Temp), &dw, NULL);
		}
		Index++;
		pFileName = (TCHAR*)SendMessage(hListBox, LB_GETITEMDATA, (WPARAM)Index, 0);
	}
	CloseHandle(hFile);
	return TRUE;
}

BOOL OpenWave()
{
	DWORD i;
	g_Format.wFormatTag = WAVE_FORMAT_PCM;
	g_Format.nChannels = 2;
	g_Format.nSamplesPerSec = 32000;
	g_Format.nAvgBytesPerSec = 2 * 32000 * 16 / 8;
	g_Format.nBlockAlign = 2 * 16 / 8;
	g_Format.wBitsPerSample = 16;
	g_Format.cbSize = 0;
	waveOutOpen(&g_hWaveOut, WAVE_MAPPER, &g_Format, 0, 0, CALLBACK_NULL);
	if(!g_hWaveOut)
		return FALSE;
	g_pBuffer = new BYTE[BUFFER_COUNT * BUFFER_SAMPLE * 4];
	if(!g_pBuffer)
		return FALSE;
	ZeroMemory(g_pBuffer, BUFFER_COUNT * BUFFER_SAMPLE * 4);
	waveOutPause(g_hWaveOut);
	waveOutReset(g_hWaveOut);
	for(i = 0; i < BUFFER_COUNT; i++)
	{
		g_Hdr[i].lpData = (LPSTR)g_pBuffer + i * BUFFER_SAMPLE * 4;
		g_Hdr[i].dwBufferLength = BUFFER_SAMPLE * 4;
		g_Hdr[i].dwFlags = 0;
		waveOutPrepareHeader(g_hWaveOut, &g_Hdr[i], sizeof(WAVEHDR));
	}
	g_bPlay = FALSE;
	g_Written = 0;
	g_bReady = TRUE;
	return TRUE;
}

void CloseWave()
{
	DWORD i;
	g_bReady = FALSE;
	if(g_hWaveOut)
	{
		waveOutPause(g_hWaveOut);
		waveOutReset(g_hWaveOut);
		for(i = 0; i < BUFFER_COUNT; i++)
			waveOutUnprepareHeader(g_hWaveOut, &g_Hdr[i], sizeof(WAVEHDR));
		waveOutClose(g_hWaveOut);
	}
	g_hWaveOut = NULL;
	if(g_pBuffer)
		delete []g_pBuffer;
	g_pBuffer = NULL;
}

DWORD GetCurrentSample()
{
	MMTIME mmt;
	ZeroMemory(&mmt, sizeof(MMTIME));
	mmt.wType = TIME_SAMPLES;
	waveOutGetPosition(g_hWaveOut, &mmt, sizeof(MMTIME));
	return mmt.u.sample;
}

void UpdateWaveBuffer()
{
	DWORD Sample;
	SHORT* pCur;
	SHORT* pEnd;
	LONG t;
	if(!g_bReady)
		return;
	if(!g_bPlay)
		return;
	Sample = GetCurrentSample();
	while(g_Written - Sample < BUFFER_PRELOAD * BUFFER_SAMPLE)
	{
		if(waveOutWrite(g_hWaveOut, &g_Hdr[(g_Written / BUFFER_SAMPLE) % BUFFER_COUNT], sizeof(WAVEHDR)) != MMSYSERR_NOERROR)
			break;
		g_Written += BUFFER_SAMPLE;
		pCur = (SHORT*)g_Hdr[(g_Written / BUFFER_SAMPLE) % BUFFER_COUNT].lpData;
		pEnd = pCur + BUFFER_SAMPLE * 2;
		g_OpenSPC.run(-1, pCur, BUFFER_SAMPLE * 4);
		while(pCur < pEnd)
		{
			if(*pCur > -16 && *pCur < 16)
				g_SilenceCount++;
			else
				g_SilenceCount = 0;
			t = *pCur * g_Volume;
			*pCur = (SHORT)(t >> 16);
			pCur++;
		}
		if(g_Position >= g_FadeoutPosition)
		{
			pCur = (SHORT*)g_Hdr[(g_Written / BUFFER_SAMPLE) % BUFFER_COUNT].lpData;
			while(pCur < pEnd)
			{
				if(g_FadeVolume > 0)
					g_FadeVolume -= g_FadeoutFactor;
				t = *pCur * (g_FadeVolume >> 8);
				*pCur = (SHORT)(t >> 16);
				pCur++;
			}
		}
		else if(g_Position + BUFFER_SAMPLE >= g_FadeoutPosition)
		{
			pCur = (SHORT*)g_Hdr[(g_Written / BUFFER_SAMPLE) % BUFFER_COUNT].lpData + (g_FadeoutPosition - g_Position) * 2;
			while(pCur < pEnd)
			{
				if(g_FadeVolume > 0)
					g_FadeVolume -= g_FadeoutFactor;
				t = *pCur * (g_FadeVolume >> 8);
				*pCur = (SHORT)(t >> 16);
				pCur++;
			}
		}
		g_Position += BUFFER_SAMPLE;
	}
}

void GetSPCTitle(TCHAR* pOut, LPCTSTR FileName, BOOL bLoad)
{
	HANDLE hFile;
	DWORD dw;
	CHAR Title[33];
	TCHAR Temp[MAX_PATH];
	pOut[0] = _T('\0');
	if(bLoad)
	{
		if(FileName)
		{
			hFile = CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
			if(hFile != INVALID_HANDLE_VALUE)
			{
				SetFilePointer(hFile, 0x0000002e, NULL, FILE_BEGIN);
				Title[0] = '\0';
				ReadFile(hFile, &Title, sizeof(CHAR) * 32, &dw, NULL);
				CloseHandle(hFile);
				Title[32] = '\0';
				MultiByteToWideChar(CP_ACP, 0, Title, -1, pOut, 33);
			}
		}
	}
	else
	{
		if(g_pFile)
		{
			Title[0] = '\0';
			memcpy(&Title, g_pFile + 0x0000002e, sizeof(CHAR) * 32);
			Title[32] = '\0';
			MultiByteToWideChar(CP_ACP, 0, Title, -1, pOut, 33);
		}
	}
	if(_tcslen(pOut) == 0)
	{
		if(FileName)
		{
			GetFileNameFromFullPath(Temp, FileName);
			Temp[32] = _T('\0');
			_tcscpy(pOut, Temp);
		}
	}
}

BOOL LoadSPCFile(LPCTSTR FileName)
{
	HANDLE hFile;
	DWORD dw;
	hFile = CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
		return FALSE;
	g_dwFile = GetFileSize(hFile, NULL);
	g_pFile = new BYTE[g_dwFile];
	if(!g_pFile)
	{
		CloseHandle(hFile);
		return FALSE;
	}
	ReadFile(hFile, g_pFile, g_dwFile, &dw, NULL);
	if(dw != g_dwFile)
	{
		CloseHandle(hFile);
		return FALSE;
	}
	CloseHandle(hFile);
	GetSPCTitle(g_SPCTitle, FileName, FALSE);
	return TRUE;
}

void FreeSPCFile()
{
	if(g_pFile)
		delete []g_pFile;
	g_pFile = NULL;
	g_dwFile = 0;
}

BOOL InitSPCFile()
{
	g_Position = 0;
	g_FadeVolume = 0x01000000;
	g_SilenceCount = 0;
	if(g_OpenSPC.init(g_pFile, g_dwFile) != 0)
		return FALSE;
	return TRUE;
}

void Play()
{
	if(!g_bReady)
		return;
	waveOutRestart(g_hWaveOut);
	g_bPlay = TRUE;
}

void Stop()
{
	if(!g_bReady)
		return;
	g_bPlay = FALSE;
	waveOutPause(g_hWaveOut);
	waveOutReset(g_hWaveOut);
	ZeroMemory(g_pBuffer, BUFFER_COUNT * BUFFER_SAMPLE * 4);
	g_Written = 0;
}

void Seek(DWORD Position)
{
	DWORD Sample;
	while(Position > g_Position)
	{
		Sample = min(Position - g_Position, BUFFER_SAMPLE);
		g_OpenSPC.run(-1, (SHORT*)g_Hdr[(g_Written / BUFFER_SAMPLE) % BUFFER_PRELOAD].lpData, Sample * g_Format.nBlockAlign);
		g_Position += Sample;
	}
	if(Position < g_Position)
	{
		InitSPCFile();
		Seek(Position);
	}
}

INT_PTR CALLBACK SettingsDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_INITDIALOG:
		SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)_T("10 sec"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)_T("30 sec"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)_T("1 min"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)_T("2 min"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)_T("3 min"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)_T("5 min"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)_T("10 min"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)_T("Infinite"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO2, CB_ADDSTRING, 0, (LPARAM)_T("None"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO2, CB_ADDSTRING, 0, (LPARAM)_T("1 sec"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO2, CB_ADDSTRING, 0, (LPARAM)_T("2 sec"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO2, CB_ADDSTRING, 0, (LPARAM)_T("4 sec"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO2, CB_ADDSTRING, 0, (LPARAM)_T("8 sec"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO2, CB_ADDSTRING, 0, (LPARAM)_T("16 sec"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO3, CB_ADDSTRING, 0, (LPARAM)_T("Never"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO3, CB_ADDSTRING, 0, (LPARAM)_T("5 sec"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO3, CB_ADDSTRING, 0, (LPARAM)_T("10 sec"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO4, CB_ADDSTRING, 0, (LPARAM)_T("100%"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO4, CB_ADDSTRING, 0, (LPARAM)_T("75%"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO4, CB_ADDSTRING, 0, (LPARAM)_T("50%"));
		SendDlgItemMessage(hwndDlg, IDC_COMBO4, CB_ADDSTRING, 0, (LPARAM)_T("25%"));
		switch(g_FadeoutPosition)
		{
		case 10 * 32000:
			SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_SETCURSEL, 0, 0);
			break;
		case 30 * 32000:
			SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_SETCURSEL, 1, 0);
			break;
		case 60 * 32000:
			SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_SETCURSEL, 2, 0);
			break;
		case 120 * 32000:
			SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_SETCURSEL, 3, 0);
			break;
		case 180 * 32000:
			SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_SETCURSEL, 4, 0);
			break;
		case 300 * 32000:
			SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_SETCURSEL, 5, 0);
			break;
		case 600 * 32000:
			SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_SETCURSEL, 6, 0);
			break;
		case 0xffffffff:
			SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_SETCURSEL, 7, 0);
			break;
		}
		switch(g_FadeoutFactor)
		{
		case 0x01000000:
			SendDlgItemMessage(hwndDlg, IDC_COMBO2, CB_SETCURSEL, 0, 0);
			break;
		case 0x00000100:
			SendDlgItemMessage(hwndDlg, IDC_COMBO2, CB_SETCURSEL, 1, 0);
			break;
		case 0x00000080:
			SendDlgItemMessage(hwndDlg, IDC_COMBO2, CB_SETCURSEL, 2, 0);
			break;
		case 0x00000040:
			SendDlgItemMessage(hwndDlg, IDC_COMBO2, CB_SETCURSEL, 3, 0);
			break;
		case 0x00000020:
			SendDlgItemMessage(hwndDlg, IDC_COMBO2, CB_SETCURSEL, 4, 0);
			break;
		case 0x00000010:
			SendDlgItemMessage(hwndDlg, IDC_COMBO2, CB_SETCURSEL, 5, 0);
			break;
		}
		switch(g_SilenceTimeout)
		{
		case 0xffffffff:
			SendDlgItemMessage(hwndDlg, IDC_COMBO3, CB_SETCURSEL, 0, 0);
			break;
		case 5 * 32000 * 2:
			SendDlgItemMessage(hwndDlg, IDC_COMBO3, CB_SETCURSEL, 1, 0);
			break;
		case 10 * 32000 * 2:
			SendDlgItemMessage(hwndDlg, IDC_COMBO3, CB_SETCURSEL, 2, 0);
			break;
		}
		switch(g_Volume)
		{
		case 0x00010000:
			SendDlgItemMessage(hwndDlg, IDC_COMBO4, CB_SETCURSEL, 0, 0);
			break;
		case 0x0000c000:
			SendDlgItemMessage(hwndDlg, IDC_COMBO4, CB_SETCURSEL, 1, 0);
			break;
		case 0x00008000:
			SendDlgItemMessage(hwndDlg, IDC_COMBO4, CB_SETCURSEL, 2, 0);
			break;
		case 0x00004000:
			SendDlgItemMessage(hwndDlg, IDC_COMBO4, CB_SETCURSEL, 3, 0);
			break;
		}
		break;
	case WM_CLOSE:
		EndDialog(hwndDlg, IDCANCEL);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			switch(HIWORD(wParam))
			{
			case BN_CLICKED:
				switch(SendDlgItemMessage(hwndDlg, IDC_COMBO1, CB_GETCURSEL, 0, 0))
				{
				case 0:
					g_FadeoutPosition = 10 * 32000;
					break;
				case 1:
					g_FadeoutPosition = 30 * 32000;
					break;
				case 2:
					g_FadeoutPosition = 60 * 32000;
					break;
				case 3:
					g_FadeoutPosition = 120 * 32000;
					break;
				case 4:
					g_FadeoutPosition = 180 * 32000;
					break;
				case 5:
					g_FadeoutPosition = 300 * 32000;
					break;
				case 6:
					g_FadeoutPosition = 600 * 32000;
					break;
				case 7:
					g_FadeoutPosition = 0xffffffff;
					break;
				}
				switch(SendDlgItemMessage(hwndDlg, IDC_COMBO2, CB_GETCURSEL, 0, 0))
				{
				case 0:
					g_FadeoutFactor = 0x01000000;
					break;
				case 1:
					g_FadeoutFactor = 0x00000100;
					break;
				case 2:
					g_FadeoutFactor = 0x00000080;
					break;
				case 3:
					g_FadeoutFactor = 0x00000040;
					break;
				case 4:
					g_FadeoutFactor = 0x00000020;
					break;
				case 5:
					g_FadeoutFactor = 0x00000010;
					break;
				}
				switch(SendDlgItemMessage(hwndDlg, IDC_COMBO3, CB_GETCURSEL, 0, 0))
				{
				case 0:
					g_SilenceTimeout = 0xffffffff;
					break;
				case 1:
					g_SilenceTimeout = 5 * 32000 * 2;
					break;
				case 2:
					g_SilenceTimeout = 10 * 32000 * 2;
					break;
				}
				switch(SendDlgItemMessage(hwndDlg, IDC_COMBO4, CB_GETCURSEL, 0, 0))
				{
				case 0:
					g_Volume = 0x00010000;
					break;
				case 1:
					g_Volume = 0x0000c000;
					break;
				case 2:
					g_Volume = 0x00008000;
					break;
				case 3:
					g_Volume = 0x00004000;
					break;
				}
				EndDialog(hwndDlg, IDOK);
				break;
			}
			break;
		case IDCANCEL:
			switch(HIWORD(wParam))
			{
			case BN_CLICKED:
				EndDialog(hwndDlg, IDCANCEL);
				break;
			}
			break;
		}
		break;
	}
	return 0;
}

LRESULT CALLBACK ListBoxProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_GETDLGCODE:
		return DLGC_WANTALLKEYS;
		break;
	case WM_KEYDOWN:
		switch(wParam)
		{
		case VK_RETURN:
			PostMessage(GetParent(hWnd), WM_COMMAND, (WPARAM)GetWindowLong(hWnd, GWL_ID) | (LBN_DBLCLK << 16), (LPARAM)hWnd);
			break;
		}
		break;
	}
	return CallWindowProc(g_OldListBoxProc, hWnd, uMsg, wParam, lParam);
}

INT_PTR CALLBACK DlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	TCHAR Temp[MAX_PATH];
	TCHAR Dir[MAX_PATH];
	OPENFILENAME ofn;
	LONG Index;
	TCHAR* pFileName;
	WIN32_FIND_DATA fd;
	HANDLE hFind;
	switch(uMsg)
	{
	case WM_INITDIALOG:
		SetWindowText(hwndDlg, MAIN_WINDOW_TEXT);
		if(!OpenWave())
		{
			PostMessage(hwndDlg, WM_CLOSE, 0, 0);
			break;
		}
		g_Position = 0;
		g_FadeVolume = 0x01000000;
		g_SilenceCount = 0;
		g_CurrentIndex = -1;
		g_OldListBoxProc = (WNDPROC)GetWindowLong(GetDlgItem(hwndDlg, IDC_LIST1), GWL_WNDPROC);
		SetWindowLong(GetDlgItem(hwndDlg, IDC_LIST1), GWL_WNDPROC, (LONG)ListBoxProc);
		_stprintf(Temp, _T("%s\\playlist.ini"), g_AppDir);
		LoadPlaylist(Temp, GetDlgItem(hwndDlg, IDC_LIST1));
		SetTimer(hwndDlg, 1, 50, NULL);
		SetTimer(hwndDlg, 2, 500, NULL);
		break;
	case WM_CLOSE:
		KillTimer(hwndDlg, 1);
		KillTimer(hwndDlg, 2);
		Stop();
		CloseWave();
		FreeSPCFile();
		_stprintf(Temp, _T("%s\\playlist.ini"), g_AppDir);
		SavePlaylist(Temp, GetDlgItem(hwndDlg, IDC_LIST1));
		EndDialog(hwndDlg, 0);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_BUTTON1:
			switch(HIWORD(wParam))
			{
			case BN_CLICKED:
				DialogBox(g_hInstance, (LPCTSTR)IDD_SETTINGS, hwndDlg, SettingsDlgProc);
				break;
			}
			break;
		case IDC_BUTTON2:
			switch(HIWORD(wParam))
			{
			case BN_CLICKED:
				if(g_bPlay)
					Stop();
				else
					Play();
				break;
			}
			break;
		case IDC_BUTTON3:
			switch(HIWORD(wParam))
			{
			case BN_CLICKED:
				Stop();
				InitSPCFile();
				break;
			}
			break;
		case IDC_BUTTON4:
			switch(HIWORD(wParam))
			{
			case BN_CLICKED:
				pFileName = (TCHAR*)SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_GETITEMDATA, (WPARAM)g_CurrentIndex - 1, 0);
				if(pFileName && pFileName != (TCHAR*)LB_ERR)
				{
					Stop();
					FreeSPCFile();
					if(LoadSPCFile(pFileName))
					{
						InitSPCFile();
						Play();
					}
					g_CurrentIndex--;
				}
				break;
			}
			break;
		case IDC_BUTTON5:
			switch(HIWORD(wParam))
			{
			case BN_CLICKED:
				pFileName = (TCHAR*)SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_GETITEMDATA, (WPARAM)g_CurrentIndex + 1, 0);
				if(pFileName && pFileName != (TCHAR*)LB_ERR)
				{
					Stop();
					FreeSPCFile();
					if(LoadSPCFile(pFileName))
					{
						InitSPCFile();
						Play();
					}
					g_CurrentIndex++;
				}
				break;
			}
			break;
		case IDC_BUTTON6:
			switch(HIWORD(wParam))
			{
			case BN_CLICKED:
				_tcscpy(Temp, g_AppPath);
				GetDirFromFullPath(Dir, Temp);
				ZeroMemory(&ofn, sizeof(OPENFILENAME));
				ofn.lStructSize = sizeof(OPENFILENAME);
				ofn.hwndOwner = hwndDlg;
				ofn.lpstrFilter = _T("SPC file (*.spc)\0*.spc\0All files (*.*)\0*.*\0");
				ofn.lpstrFile = Temp;
				ofn.nMaxFile = MAX_PATH;
				ofn.lpstrInitialDir = Dir;
				ofn.lpstrTitle = _T("Choose a file");
				ofn.Flags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
				if(GetOpenFileName(&ofn))
				{
					Stop();
					FreeSPCFile();
					if(LoadSPCFile(Temp))
						InitSPCFile();
				}
				break;
			}
			break;
		case IDC_LIST1:
			switch(HIWORD(wParam))
			{
			case LBN_DBLCLK:
				Index = (LONG)SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				if(Index >= 0)
				{
					pFileName = (TCHAR*)SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_GETITEMDATA, (WPARAM)Index, 0);
					if(pFileName)
					{
						Stop();
						FreeSPCFile();
						if(LoadSPCFile(pFileName))
						{
							InitSPCFile();
							Play();
						}
						g_CurrentIndex = Index;
					}
				}
				break;
			}
			break;
		case IDC_BUTTON7:
			switch(HIWORD(wParam))
			{
			case BN_CLICKED:
				_tcscpy(Temp, g_AppPath);
				GetDirFromFullPath(Dir, Temp);
				ZeroMemory(&ofn, sizeof(OPENFILENAME));
				ofn.lStructSize = sizeof(OPENFILENAME);
				ofn.hwndOwner = hwndDlg;
				ofn.lpstrFilter = _T("SPC file (*.spc)\0*.spc\0All files (*.*)\0*.*\0");
				ofn.lpstrFile = Temp;
				ofn.nMaxFile = MAX_PATH;
				ofn.lpstrInitialDir = Dir;
				ofn.lpstrTitle = _T("Choose a file");
				ofn.Flags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
				if(GetOpenFileName(&ofn))
				{
					pFileName = new TCHAR[MAX_PATH];
					if(pFileName)
					{
						_tcscpy(pFileName, Temp);
						GetSPCTitle(Dir, Temp, TRUE);
						Index = (LONG)SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_ADDSTRING, 0, (LPARAM)Dir);
						if(Index >= 0)
							SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_SETITEMDATA, (WPARAM)Index, (LPARAM)pFileName);
					}
				}
				break;
			}
			break;
		case IDC_BUTTON8:
			switch(HIWORD(wParam))
			{
			case BN_CLICKED:
				_tcscpy(Temp, g_AppPath);
				GetDirFromFullPath(Dir, Temp);
				ZeroMemory(&ofn, sizeof(OPENFILENAME));
				ofn.lStructSize = sizeof(OPENFILENAME);
				ofn.hwndOwner = hwndDlg;
				ofn.lpstrFilter = _T("SPC file (*.spc)\0*.spc\0All files (*.*)\0*.*\0");
				ofn.lpstrFile = Temp;
				ofn.nMaxFile = MAX_PATH;
				ofn.lpstrInitialDir = Dir;
				ofn.lpstrTitle = _T("Choose a file");
				ofn.Flags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
				if(GetOpenFileName(&ofn))
				{
					GetDirFromFullPath(Dir, Temp);
					_stprintf(Temp, _T("%s\\*.spc"), Dir);
					hFind = FindFirstFile(Temp, &fd);
					if(hFind != INVALID_HANDLE_VALUE)
					{
						do
						{
							pFileName = new TCHAR[MAX_PATH];
							if(pFileName)
							{
								_stprintf(pFileName, _T("%s\\%s"), Dir, fd.cFileName);
								GetSPCTitle(Temp, pFileName, TRUE);
								Index = (LONG)SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_ADDSTRING, 0, (LPARAM)Temp);
								if(Index >= 0)
									SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_SETITEMDATA, (WPARAM)Index, (LPARAM)pFileName);
							}
						}
						while(FindNextFile(hFind, &fd));
						FindClose(hFind);
					}
				}
				break;
			}
			break;
		case IDC_BUTTON9:
			switch(HIWORD(wParam))
			{
			case BN_CLICKED:
				Index = (LONG)SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_GETCURSEL, 0, 0);
				if(Index >= 0)
				{
					pFileName = (TCHAR*)SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_GETITEMDATA, (WPARAM)Index, 0);
					if(pFileName)
					{
						SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_SETITEMDATA, (WPARAM)Index, (LPARAM)NULL);
						delete []pFileName;
					}
					SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_DELETESTRING, (WPARAM)Index, 0);
					if(Index <= g_CurrentIndex)
						g_CurrentIndex--;
				}
				break;
			}
			break;
		case IDC_BUTTON10:
			switch(HIWORD(wParam))
			{
			case BN_CLICKED:
				Index = 0;
				pFileName = (TCHAR*)SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_GETITEMDATA, (WPARAM)Index, 0);
				while(pFileName != (TCHAR*)LB_ERR)
				{
					SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_SETITEMDATA, (WPARAM)Index, (LPARAM)NULL);
					if(pFileName)
						delete []pFileName;
					Index++;
					pFileName = (TCHAR*)SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_GETITEMDATA, (WPARAM)Index, 0);
				}
				SendDlgItemMessage(hwndDlg, IDC_LIST1, LB_RESETCONTENT, 0, 0);
				g_CurrentIndex = -1;
				break;
			}
			break;
		}
		break;
	case WM_TIMER:
		switch(wParam)
		{
		case 1:
			if((g_Position >= g_FadeoutPosition && g_Position - g_FadeoutPosition >= 0x01000000 / (DWORD)g_FadeoutFactor / 2 + BUFFER_PRELOAD * BUFFER_SAMPLE) || g_SilenceCount >= g_SilenceTimeout)
			{
				Stop();
				PostMessage(hwndDlg, WM_COMMAND, IDC_BUTTON5 | (BN_CLICKED << 16), (LPARAM)GetDlgItem(hwndDlg, IDC_BUTTON3));
			}
			UpdateWaveBuffer();
			break;
		case 2:
			_stprintf(Temp, _T("%s\n%02u:%02u %s"), g_SPCTitle, g_Position / (60 * 32000), (g_Position / 32000) % 60, (g_bPlay ? _T("Playing") : _T("Paused")));
			SetDlgItemText(hwndDlg, IDC_STATIC1, Temp);
			break;
		}
		break;
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	HWND hWnd;
	TCHAR Temp[MAX_PATH];
	hWnd = FindWindow(MAIN_WINDOW_CLASS, MAIN_WINDOW_TEXT);
	if(hWnd)
	{
		SetForegroundWindow(hWnd);
		return 0;
	}
	SetAppDir();
	g_hInstance = hInstance;
	g_Volume = 0x00010000;
	g_FadeoutPosition = 120 * 32000;
	g_FadeoutFactor = 0x00000040;
	g_SilenceTimeout = 5 * 32000 * 2;
	_stprintf(Temp, _T("%s\\settings.ini"), g_AppDir);
	LoadSettings(Temp);
	DialogBox(g_hInstance, (LPCTSTR)IDD_MAIN, NULL, DlgProc);
	_stprintf(Temp, _T("%s\\settings.ini"), g_AppDir);
	SaveSettings(Temp);
	return 0;
}

